# Documentation

Swinject is a lightweight dependency injection framework for Swift apps. It allows you to split your app into loosely-coupled components, which can then be maintained and tested more easily. Swinject <a name="pure-swift-type-support">supports pure Swift types</a>, and is powered by the Swift generic type system and [first class functions](https://en.wikipedia.org/wiki/First-class_function).  This makes it syntactically elegant and simple to define the object dependencies for your app.

## Table of Contents

### Basics

1. [DI Container](DIContainer.md)
2. [Injection Patterns](InjectionPatterns.md)
3. [Circular Dependencies](CircularDependencies.md)
4. [Object Scopes](ObjectScopes.md)
5. [Misc](Misc.md)

### Advanced Features

1. [Container Hierarchy](ContainerHierarchy.md)
2. [Properties](Properties.md)
3. [Modularizing Service Registration](Assembler.md)
4. [Thread Safety](ThreadSafety.md)

### UI Features

1. [Storyboard](Storyboard.md)

### Extensions

1. [Swinject-CodeGen](https://github.com/Swinject/Swinject-CodeGen)
